import * as THREE from 'three';
import { iCSMParams, iCSMUpdateParams, MaterialConstructor, Uniform } from './types';
export default class CustomShaderMaterial<T extends MaterialConstructor = typeof THREE.Material> extends THREE.Material {
    uniforms: Uniform;
    private __csm;
    constructor({ baseMaterial, //
    fragmentShader, vertexShader, uniforms, patchMap, cacheKey, ...opts }: iCSMParams<T>);
    update(opts?: iCSMUpdateParams<T>): void;
    clone(): this;
    private generateMaterial;
    private getMaterialDefine;
    private getPatchMapForMaterial;
    private patchShader;
    private parseShader;
    private getShaderFromIndex;
}
export * from './types';
